<?php
	class MigrationGuestbook2_0
	{
		var $success;
		var $mass_settings;
		
		function MigrationGuestbook2_0($mass_settings) {
			$this->success = false;
			$this->mass_settings = $mass_settings;
		}
		
		function MigrationContentGB2_0() {
			include_once 'classes/config.php';
			if (!defined('source')) {
				return false;
			}
			switch(strtolower(source))
			{
				case 'files':
					 $old_content = $this->MigrationContentFilesGB2_0('classes/file.txt');
					 break;
					
				case 'mysql':
					 if(!defined('mysql_host') || !defined('mysql_user') || !defined('mysql_password') || !defined('mysql_database_name')){
					 	return;
					 }
					 //$this->MigrationContentMysqlGB2_0(mysql_host, mysql_user, mysql_password, mysql_database_name);
					 break;

				case 'sqlite':
					 //
					 //$old_content = $this->MigrationContentSqliteFilesGB2_0('dump');
					 return;
					 break;
					
				default: 
				     $this->success = false;
				     return;	
			}
			
			if($this->success){
				 $this->MigrationContentGB2_1($old_content);
			}
			return true;
		}
		
		function MigrationContentFilesGB2_0($old_path) {
			if(!file_exists($old_path)){
				$this->success = false;
			}
			$file_content = @file($old_path);
			$this->success = true;
			return $file_content;
		}
		
		function MigrationContentGB2_1($old_content)
		{
			switch($this->mass_settings['type_db'])
			{
				case 'files':
					$this->MigrationContentFilesGB2_1($old_content);
					break;
					
				case 'sqlite':
					$this->MigrationContentSqliteGB2_1($old_content);
					break;
					
				case 'mysql':
					$this->MigrationContentMysqlGB2_1($old_content);
					break;
			}
		}
		
		function MigrationContentFilesGB2_1($old_content)
		{
			$str = implode('',$old_content);
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
			$fp = fopen($dataDir.$this->mass_settings['module_id'].'.txt', 'w');
			fwrite($fp, $str);
			fclose($fp);
		}
		
		function MigrationContentSqliteGB2_1($old_content)
		{
			$mass = array();
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
			$con = sqlite_open($dataDir . $this->mass_settings['module_id'].'.bin');
            for($i=0; $i<sizeof($old_content); $i++) {
                $mass = explode(":::",$old_content[$i]);
            	$sql = "INSERT INTO mod_guestbook(name,homepage,email,time_,comments,sess_id)
            			VALUES('".$mass[1]."', '".$mass[2]."', '".$mass[3]."', '".$mass[4]."', '".$mass[5]."', '".$mass[6]."')";
            	sqlite_query($sql);
            }
			sqlite_close($con);
		}
		
		function MigrationContentMysqlGB2_1($old_content)
		{
			$mass = array();
			$con = @mysql_connect($this->mass_settings['host_db'], $this->mass_settings['user_db'], $this->mass_settings['passwd_db']);
			
			if(!$con){
				return false;
			}
			
			if(!mysql_select_db($this->mass_settings['db_name'])){
				return false;
			}
			
            for($i=0; $i<sizeof($old_content); $i++)
            {
                $mass = explode(":::",$old_content[$i]);
/*                $id = $mass[0];
                $name = $mass[1];
                $homepage = $mass[2];
                $email = $mass[3];
                $data = $mass[4];
                $comments = $mass[5];
                $sess_id = $mass[6];
*/                
            	$sql = "INSERT INTO ".$this->mass_settings['module_id']."_mod_guestbook(name,homepage,email,time_,comments,sess_id)
            			VALUES('".$mass[1]."', '".$mass[2]."', '".$mass[3]."', '".$mass[4]."', '".$mass[5]."', '".$mass[6]."')";
            	mysql_query($sql);
            }
			mysql_close($con);
		}
	}
	
	function MigrationGuestbook2_0($mass_settings) {
		if (isset($mass_settings['module_id']) && file_exists('classes/config.php') && !file_exists('../data/'.$mass_settings['module_id'].'.migrationguestbook.txt')) {
			$mig_obj = new MigrationGuestbook2_0($mass_settings);
			$mig_obj->MigrationContentGB2_0();
			$fp = fopen('../data/'.$mass_settings['module_id'].'.migrationguestbook.txt', 'w');
			fwrite($fp,'true');
			fclose($fp);
		}
	}

?>