<?php
     class FILES
     {
        var $file_name;

		function FILES() {
			$dataDir = '../data/';
			if (!file_exists($dataDir)) {
				mkdir($dataDir);
				chmod($dataDir, 0777);
			}
			$this->file_name = $dataDir.$GLOBALS['mass_settings']['module_id'].'.txt';
			if(!file_exists($this->file_name)) {
				$fp = @fopen($this->file_name,"w");
				@fclose($fp);
			}
		}
        
        function close_db(){
        }
        
        function getContentFile() {
            $content="";
            if (file_exists($this->file_name) && is_readable($this->file_name)) {
               $content = file($this->file_name);
            }
            return $content;
        }
        
        function setContentFile($content,$mode) {
            if(file_exists($this->file_name))
            {
                $fp=@fopen($this->file_name,$mode);
                flock($fp, LOCK_EX);
                fwrite($fp,$content);
                flock($fp, LOCK_UN);
                fclose($fp);
            }
        }
        
        function getAllMess() {
            $mass = array();
            $content = $this->getContentFile();
            $mass = $this->sort_message($content);
            return $mass;
        }
        
        function sort_message($mass) {
            $sort_mass=array();
            for($i=0; $i<sizeof($mass); $i++) {
                $sort_mass[$i] = explode(":::",$mass[$i]);
            }

            for($i=0; $i<sizeof($sort_mass); $i++) {
                for($j=0; $j<sizeof($sort_mass)-1; $j++) {
                   if($sort_mass[$j][4]<$sort_mass[$j+1][4]) {
                       $id = $sort_mass[$j][0];
                       $name = $sort_mass[$j][1];
                       $homepage = $sort_mass[$j][2];
                       $email = $sort_mass[$j][3];
                       $data = $sort_mass[$j][4];
                       $comments = $sort_mass[$j][5];
                       $sess_id = $sort_mass[$j][6];

                       $sort_mass[$j][0] = $sort_mass[$j+1][0];
                       $sort_mass[$j][1] = $sort_mass[$j+1][1];
                       $sort_mass[$j][2] = $sort_mass[$j+1][2];
                       $sort_mass[$j][3] = $sort_mass[$j+1][3];
                       $sort_mass[$j][4] = $sort_mass[$j+1][4];
                       $sort_mass[$j][5] = $sort_mass[$j+1][5];
                       $sort_mass[$j][6] = $sort_mass[$j+1][6];

                       $sort_mass[$j+1][0] = $id;
                       $sort_mass[$j+1][1] = $name;
                       $sort_mass[$j+1][2] = $homepage;
                       $sort_mass[$j+1][3] = $email;
                       $sort_mass[$j+1][4] = $data;
                       $sort_mass[$j+1][5] = $comments;
                       $sort_mass[$j+1][6] = $sess_id;
                   }
                }
            }
            return $sort_mass;
         }
         
         function addMess($message) {
            $this->setContentFile($message,"a+");
         }
         
         function delMess($mess_id) {
             $mass = array();
             $content = $this->getContentFile();
             
             for ($i=0; $i<sizeof($content); $i++) {
                $mass[$i] = explode(":::",$content[$i]);
             }
             $new_messages="";
             for ($i=0; $i<sizeof($mass); $i++) {
                if (intval($mass[$i][0]) != intval($mess_id)) {
                   $new_messages .= $mass[$i][0].":::".$mass[$i][1].":::".$mass[$i][2].":::".$mass[$i][3].":::".$mass[$i][4].":::".$mass[$i][5].":::".$mass[$i][6].":::\n";
                }
             }
             $this->setContentFile($new_messages,"w");
         }
         
         function editMess($user_id, $user_name, $comments, $homepage, $email) {
             $content = $this->getContentFile();
             $mass = array();
             for ($i=0; $i<sizeof($content); $i++) {
                $mass[$i] = explode(":::",$content[$i]);
                if (intval($mass[$i][0]) == intval($user_id)) {
                    $mass[$i][0] = $user_id;
                    $mass[$i][1] = $user_name;
                    $mass[$i][2] = $homepage;
                    $mass[$i][3] = $email;
                    $mass[$i][4] = time();
                    $mass[$i][5] = $comments;
                    $mass[$i][6] = session_id();
                }
             }

             $new_messages="";
             for ($i=0; $i<sizeof($mass); $i++) {
                  $new_messages .= $mass[$i][0].":::".$mass[$i][1].":::".$mass[$i][2].":::".$mass[$i][3].":::".$mass[$i][4].":::".$mass[$i][5].":::".$mass[$i][6].":::\n";
             }
             $this->setContentFile($new_messages,"w");
         }
     }

     class SQLITE {
          var $con;

          function SQLITE() {
                if(!function_exists("sqlite_open"))  {
                  echo "On a host the extension sqlite.so is not used. Please contact your administrator.";
                  exit();
                }
				$dataDir = '../data/';
				if (!file_exists($dataDir)) {
					mkdir($dataDir);
					chmod($dataDir, 0777);
				}
				$sqlite_file = $dataDir . $GLOBALS['mass_settings']['module_id'].'.bin';
				if (!file_exists($sqlite_file)) {
					$db = @sqlite_open($sqlite_file);
					@sqlite_query($db,
						"CREATE TABLE mod_guestbook (
							id INTEGER PRIMARY KEY,
							name CHAR(50),
							homepage CHAR(50),
							email  CHAR(50),
							time_ CHAR(20),
							comments TEXT, 
							sess_id CHAR(50) )"
					);
				} 		
				$this->con = @sqlite_open($sqlite_file);
          }

          function is_empty_Query($result) {
             return @sqlite_num_rows($result);
          }

          function getQuery($sql)
          {
               $result = @sqlite_query($this->con, $sql);
               return $result;
          }

          function setQuery($sql){
               @sqlite_query($this->con, $sql);
          }
          
          function fetch_array($result)
          {
               return @sqlite_fetch_array($result);
          }
          
          function close_db()
          {
               @sqlite_close($this->con);
          }
          
          function count_rows()
          {
             $sql = "SELECT COUNT() kol FROM mod_guestbook";
             $query = $this->getQuery($sql);
             $result = $this->fetch_array($query);
             return $result["kol"];
          }
          
          function getAllMess()
          {
             $mass = array();
             $sql = "SELECT * FROM mod_guestbook ORDER BY time_ DESC";
             $result = $this->getQuery($sql);

             while ($row = $this->fetch_array($result))
             {
                $mass[] = $row;
             }
             return $mass;
          }
          
          function addMess($message)
          {
              $params = explode(":::",$message);
              $name_rows = "name, homepage, email, time_, comments, sess_id";
              $value_rows ="'".$params[1]."','".$params[2]."','".$params[3]."','".$params[4]."','".$params[5]."','".$params[6]."'";
              $sql = "INSERT INTO mod_guestbook(".$name_rows.")"." VALUES(".$value_rows.")";
              $this->setQuery($sql);
          }
          
          function delMess($mess_id)
          {
            $sql = "DELETE FROM mod_guestbook WHERE id=".$mess_id;
            $this->setQuery($sql);
          }

          function editMess($user_id, $user_name, $comments, $homepage, $email)
          {
            $sql = "UPDATE mod_guestbook SET name='$user_name', comments='$comments', homepage='$homepage', email='$email', time_='".time()."', sess_id='".session_id()."' WHERE id=".$user_id;
            $this->setQuery($sql);
          }
    }
    
    class MYSQL
    {
          var $con;
          var $module_id;
          
          function mysql($host,$user,$passwd,$db_name,$module_id)
          {
              $this->module_id = $module_id;              
          	
          	  if(!function_exists("mysql_connect"))
              {
                  echo "On this host database Mysql don't use";
                  exit();
              }
               
              $this->con = @mysql_connect($host,$user,$passwd);
              $sql = "CREATE DATABASE IF NOT EXISTS ".$db_name;
              $this->setQuery($sql);

              @mysql_select_db($db_name);
              $sql = "CREATE TABLE IF NOT EXISTS ".$this->module_id."_mod_guestbook
                      (
                          id int(10) unsigned NOT NULL auto_increment,
                          name varchar(50) NOT NULL,
                          homepage varchar(50) NOT NULL,
                          email varchar(50) NOT NULL,
                          time_ varchar(20) NOT NULL,
                          comments text NOT NULL,
                          sess_id varchar(50) NOT NULL,
                          PRIMARY KEY  (id)
                      )";
              $this->setQuery($sql);

          }

          function getQuery($sql)
          {
               $result = @mysql_query($sql,$this->con);
               return $result;
          }

          function setQuery($sql)
          {
               @mysql_query($sql,$this->con);
          }

          function fetch_array($result)
          {
               $result = @mysql_fetch_array($result);
               return $result;
          }

          function close_db()
          {
               @mysql_close($sql,$this->con);
          }
          
          function is_empty_Query($result)
          {
              return @mysql_num_rows($result);
          }

          function count_rows()
          {
             $sql = "SELECT COUNT(*) as id FROM ".$this->module_id."_mod_guestbook";
             $query = $this->getQuery($sql);
             $result = $this->fetch_array($query);
             return $result["id"];
          }
          
          function getAllMess()
          {
             $mass = array();
             $sql = "SELECT * FROM ".$this->module_id."_mod_guestbook ORDER BY time_ DESC";
             $result = $this->getQuery($sql);

             while ($row = $this->fetch_array($result))
             {
                $mass[] = $row;
             }
             return $mass;
          }

          function addMess($message)
          {
              $params = explode(":::",$message);
              $name_rows = "name, homepage, email, time_, comments, sess_id";
              $value_rows ="'".$params[1]."','".$params[2]."','".$params[3]."','".$params[4]."','".$params[5]."','".$params[6]."'";
              $sql = "INSERT INTO ".$this->module_id."_mod_guestbook(".$name_rows.")"." VALUES(".$value_rows.")";
              $this->setQuery($sql);
          }

          function delMess($mess_id)
          {
            $sql = "DELETE FROM ".$this->module_id."_mod_guestbook WHERE id=".$mess_id;
            $this->setQuery($sql);
          }

          function editMess($user_id, $user_name, $comments, $homepage, $email)
          {
            $sql = "UPDATE ".$this->module_id."_mod_guestbook SET name='$user_name', comments='$comments', homepage='$homepage', email='$email', time_='".time()."', sess_id='".session_id()."' WHERE id=".$user_id;
            $this->setQuery($sql);
          }

    }
    
    class guestbook_db
    {
        var $db;
        var $all_mess;
        var $len;

        function guestbook_db($params)
        {
            switch($params["type_db"])
            {
                case "files":
                     $this->db = new FILES();
                     break;

                case "sqlite":
                     $this->db = new SQLITE();
                     break;

                case "mysql":
                     $this->db = new mysql($params["host_db"],$params["user_db"],$params["passwd_db"],$params["db_name"], $params["module_id"]);
                     break;
            }
        }
        
        function getAllMess()
        {
           $this->all_mess = $this->db->getAllMess();
           $this->len  = sizeof($this->all_mess);
           return $this->all_mess;
        }
        
        function getCountElements()
        {
           return $this->len;
        }
        
        function addMess($message)
        {
           $this->db->addMess($message);
        }
        
        function delMess($mess_id)
        {
           $this->db->delMess($mess_id);
        }
        
        function editMess($user_id, $user_name, $comments, $homepage, $email)
        {
           $this->db->editMess($user_id, $user_name, $comments, $homepage, $email);
        }
        
		function close_db(){
			$this->db->close_db();
		}
    }
?>
