<?php

    function checkString_guestbook( $str )
    {
        $tmp = str_replace( '&', '&amp;', $str );
        $tmp = str_replace( '>', '&gt;', $tmp );
        $tmp = str_replace( '<', '&lt;', $tmp );
        $tmp = str_replace( '"', '&quot;', $tmp );
        $tmp = str_replace( "'", '&#39;', $tmp );
        $tmp = str_replace( "%", '&#37;', $tmp );
        $tmp = str_replace( "\n", '<br>', $tmp );
        $tmp = str_replace( "\r", '', $tmp);
        $tmp = str_replace( '\\', "&#92;", $tmp);
        return $tmp;
    }

    function utfStrlen($str)
    {
        return strlen(utf8_decode($str));
    }


    function utfWordWrap($str, $width, $spliter=" ")
    {
        $width = round($width);
        $len = strlen($str);
        $utf_len = utfStrlen($str);

        if ($utf_len > $width)
        {
          $new_str = '';
          $count=0;

          for($i=0; $i < $len; $i++)
          {
            $new_str .= $str[$i];
            if ((ord($str[$i]) & 0xC0) != 0x80) $count++;
            if ($str[$i]==$spliter) $count=0;
            if ($count==$width && isset($str[$i+1]) && (ord($str[$i+1]) & 0xC0) != 0x80)
            {
                $new_str .= $spliter;
                $count=0;
            }
          }
          return $new_str;
       }
       
       return $str;
    }
?>
